from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util
from Property import Property

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('WSPasswordLocator')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereWSPasswordLocator");
  exportedObject.put("roleName", "WebSphereWSPasswordLocator");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wspasswordlocator.name", objid, "name","WSPasswordLocator");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wspasswordlocator.classname", objid, "className","WSPasswordLocator");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  typeFolders = {};
  extraObjects = Property.exportProperties(objid, respath, extraObjects, typeFolders, 'Property',"WSPasswordLocator");
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('WSPasswordLocator');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('WSPasswordLocator')
  if not jsonobject.has("roleProperties"):
    raise Exception("WSPasswordLocator resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.wspasswordlocator.name", None));
  Util.addIfNotNone(properties, "className", roleProperties.optString("websphere.wspasswordlocator.classname", None));
  print "Creating WSPasswordLocator with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("WSPasswordLocator", parentid, properties);
  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('WSPasswordLocator');

def update(objid,jsonobject):
  Util.pushPathElement('WSPasswordLocator')
  if not jsonobject.has("roleProperties"):
    raise Exception("WSPasswordLocator resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wspasswordlocator.name", None), "name","WSPasswordLocator");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wspasswordlocator.classname", None), "className","WSPasswordLocator");
  if len(atts) != 0:
    print "Modifying WSPasswordLocator with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "WSPasswordLocator configuration up to date.";

  Property.removeProperties(objid, 'Property',"WSPasswordLocator");

  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('WSPasswordLocator');
